#define  Version "160123"
//modif  suite test Appinventor2
// separateur ; entre les datas

//#define  Version "18 Janv 2016"
#define BT_NAME "HC06-2187-J"
#define OSCILLATEUR_INTERNE
#define With_LCD_I2C
#define WITH_HID_Terminal

// test OK avec Bluesoleil PC

// Problemo:
// led verte sur RB1     ... same pin as  I2C1  SCL
// led verte passe via un fil F-F sur pin RB4 => compilation conditionnelle
// Timer1 pass  100mS pour tester clignotement STATE HC06

// rajout LCD 4x20 car  en I2C1
// oblige de deplacer HC06_STATE sur RB2 car I2C dispo uniquement sur RB0 RB1
// Essai du LCD 4x20 I2C mode
// SCL = 4 connecteur  LCD --> B1 18F2550
// SDA =3 connecteur LCD -> B0 18F2550
// il faut bien rajouter des resistances de rappel sur L'I2C ..les pull ub PORTB ne suffusent pas


// 16 Janvier
// rajout test STATE HC06 sur input RB0
// si on detect un passage  Zero, c'est qu'on clignote et donc
// aps appaair ou connect
// led fixe STATE=1 => OK

// beaucoup de difficulte pur reception via interrupt
// test bad  9600 bds avec interface 2TR  COM terminal sur PII400 WIN XP
//  L'oscillo pics sur front signal TTL RX
// test OK avec interface Prolific  / terminal sur PII400 WIN XP
// pas de pic sur le signal RX (propre)

// Attention aussi  la confusion COM6 et COM4  avec BlueSoleil
// UART PIC  <-- COM6  transport BT -> PC <--->  COM4 <---> Terminal

//#define FOSC_Q_8MHz

 //ac:Schema
 
  //ac:datasheet
  
  

// MikroC Pro 6.50
// Hardware :
// StartUSB 18F250 Mikroelectronika
// Q=8Mhz   => 48MHz avec le bootloader en place!
// led verte sur RB1     ... problemo avec SCl
// led Jaune sur RA1
// potar sur RA0
// USART sur RC6 et RC7 -> Module BT JY-MCU BT Board V1.4  6 Pins
// Module reconnu par blue soleil
//   HC06-2187-J    ( J=pastille jaune)   code pin : 1234
// bluesoleil : actualiser les service  PORT A : COM4
// service du PORT serie A (COM6)
// lancer Terminal Vbray et COM4 9600,8,N,1

/*
TOOLS      
MikroC PRO V 6.50
MikroC Microbootloader
PROJET :  18F2550_Startup_USB_test.mcppi
DIRECTORY :  C:\_MikroC\_MesProjets_MikroC\_18F2550_BT
SOURCE :
CONFIG :
EEPROM   :...._EEPROM.ihex

//#define FOSC_INTERNE
CONFIG1L : $300000 : 0x0021
CONFIG1H : $300001 : 0x0008
CONFIG2L : $300002 : 0x0019
CONFIG2H : $300003 : 0x001E
CONFIG3H : $300005 : 0x0083
CONFIG4L : $300006 : 0x0081
CONFIG5L : $300008 : 0x000F
CONFIG5H : $300009 : 0x00C0
CONFIG6L : $30000A : 0x000F
CONFIG6H : $30000B : 0x00E0
CONFIG7L : $30000C : 0x000F
CONFIG7H : $30000D : 0x0040

----------------------------------------
//#define FOSC_Q_8MHz
FOSC= Q8Mhz     USB : 96/2=48Mhz
CONFIG1L : $300000 : 0x0021
CONFIG1H : $300001 : 0x0000
CONFIG2L : $300002 : 0x001F
CONFIG2H : $300003 : 0x001E
CONFIG3H : $300005 : 0x0083
CONFIG4L : $300006 : 0x0081
CONFIG5L : $300008 : 0x000F
CONFIG5H : $300009 : 0x00C0
CONFIG6L : $30000A : 0x000F
CONFIG6H : $30000B : 0x00E0
CONFIG7L : $30000C : 0x000F
CONFIG7H : $30000D : 0x0040
*/


#include "built_in.h"    // for Hi Lo use

#ifndef Byte
#define Byte unsigned char
#endif

#define MAXLEN1 80
//#define DureeCycle 4              // 0.25*4 => 1sec
//#define DureeCycle 10              // 0.1*10 => 1sec
#define DureeCycle 15              // 0.1*15 => 1,5sec

#define CLS 12
#define BS 8
#define TAB 9
#define CR 13
#define LF 10
#define Bell 7
#define ON 0        // logique inverse avec led tiree au +5V
#define OFF 1

sbit Led_Rouge  at  LATA1_bit;

sbit Led_Rouge_Direction at  TRISA1_bit;

#ifdef With_LCD_I2C
sbit Led_Verte_Direction at  TRISB4_bit;
sbit Led_Verte  at  LATB4_bit;
 #else
sbit Led_Verte_Direction at  TRISB1_bit;
sbit Led_Verte  at  LATB1_bit;
#endif



sbit HC06_Enable at  LATA4_bit;
sbit HC06_Enable_Direction at  TRISA4_bit;
sbit HC06_STATE at PORTB.B2;
sbit HC06_STATE_Direction at TRISB2_bit;


#define LCD4x20_I2


#define LCD_ADDR 0x4E     // PCF8574 on pigboard YwRobot back located  on LCD4x20
// PCF8574 I2C LCD Port Definition
// P7,P6,P5,P4 = Data, P3=Backlight (BL), P2=E, P1=RW, P0=RS
#define LCD_BL 0x08
#define LCD_EN 0x04
#define LCD_RW 0x02
#define LCD_RS 0x01

// ref : ODT OCM-20416D-A2023 LCD Module  8/4/1999
// LCD Command
#define LCD_CLEAR 0x01
#define LCD_HOME  0x02
#define Display_ON 0x0C
#define Display_OFF 0x08
#define LCD_LINE1 0x80      // 0x00 + bit D7=1
#define LCD_LINE2 0xC0      // 0x40 + bit D7=1
#define LCD_LINE3 0x94      // 0x14 + bit D7=1
#define LCD_LINE4 0xD4      // 0x54 + bit D7=1


const char chaine0[]="18F2550_Startup_USB_test_BlueTooth_LCD_"Version".c\r\n";
const char chaine1[]="Cdes= RED_ON, RED_OFF,GREE_ON, TOGGLE (ADC mesure) \r\n";
const char chaine2[]=" Error de COM : ";
const char mesg0[]="                    ";

const char *RS_Str[]={chaine0,chaine1,chaine2};

#ifdef  WITH_HID_Terminal
#include "USBdescriptor_STARTUSB_18F2550.c"
unsigned char readbuff[64]  absolute 0x500; // place the arrays to USB section
unsigned char writebuff[64] absolute 0x540;
#endif

// =========  Variables =================
unsigned char Buffer1[MAXLEN1];        // buffer de reception
volatile char  c1;
volatile int Flag_Buffer1;
volatile int Index1;
volatile unsigned int i1;
volatile int CptFO,CptFE;
char *p1;

char Texte[MAXLEN1]="\0";
char *txt;
Byte CRam1[32];

volatile unsigned int Secondes;
volatile  int Flag_Timer1=0;

unsigned int  i,j,k;
unsigned int M;
unsigned long L;
float f1;
unsigned int Nb;
unsigned int Ch, EAx,EA0;

int Etat,addr;

// 8 Drapeaux  disposition
volatile struct chbits {   // 8 flags
                 unsigned Empty:1;
                 unsigned Lcd:1;
                 unsigned Elligible:1;
                 unsigned Toggle:1;
                 unsigned Blc:1;
                 unsigned standby:1;
                 unsigned Fill:1;
                 unsigned Alive:1;
               }Drapeaux ;

// utile lorsqu'on a LCD & UART  en meme temps
#define OUT_RS232   Drapeaux.Lcd=0;

void strConstRamCpy(unsigned char *dest, const code char *source) ;
void UART1_Write_String( char *s);
void UART1_Write_CTextt(const char *s);
void CRLF(void);
void Write_Word_(unsigned int M,char Sign);
//void fltToa (float x, unsigned char *str,char precision);
char * VirguleToAscii(float chiffreDeci);

//---- EEPROM PIC Subroutines ================
void Save_Msg_To_EEPROM(unsigned int * adrx, unsigned char *ptr1);
void PrintOut_Eeprom_Msg(unsigned int *PtrE);
void  UART1_Write_CText(const code char *T1) ;

void  Init_Hardware(void);
void Init_Timer1(void);
void Init_ADC();
unsigned int  Mesure_ADC(int Channel);
void Raz_COM(void) ;
int  Init_BT_HC06(void);


unsigned char I2C_PCF8574_Write(unsigned char  Adr,unsigned char value);
void LCD_init_4x20(void);
void LCD_putcmd(unsigned char d,unsigned char cmdtype);
void LCD_putch(unsigned char d);
void LCD_puts(char *s);
void LCD_putsRom(code char *s);

//fonctions LCD derives
void LCD_CLS(void);
void LCD_Msg_Status(const char* T);  // affiche un TEXTE en ligne 4
void LCD_Write_CText(const char *txt) ;
void LCDHandler(char c)   ;
void Erase_Line(int L);


void void InterruptVectorHigh() iv 0x0008 ics ICS_AUTO
 {
  static unsigned int Count1;      // mis a zero seulement au 1er passage
  static unsigned int Count11;
 if ( (RCIE_bit) && ( RCIF_bit))
   {
   // TXREG='#';
   // traitement separe des erreurs de COM
      if (RCSTA.OERR==1)    // voir parag 16.1.26 p273
      {
       RCSTA.CREN = 0 ;
        _asm nop ;
         _asm nop;
       RCSTA.CREN = 1 ;
       CptFO++;
       }
      if(RCSTA.FERR==1 )
      {
        CptFE++;
        c1 = RCREG;
        // c1 =  UART1_Read();
       }
     //c1 =  UART1_Read();
      c1= RCREG;
     if(i1>=MAXLEN1)
     {
        Flag_Buffer1=2;
        RCIE_bit=0;  //interdit IT Reception UART
        i1=0;
        Index1--;
        c1=0;
      }
     if (c1==CR)
      {
     // TXREG='@';
      Flag_Buffer1=1;
      Buffer1[i1]=0;
      Index1=i1;
      i1=0;
     }
     else
     {
        Buffer1[i1]=c1;
        Index1=i1;
        i1++;

      }
   }  //if PIR1.RCIE

  // =====  Timer1 interrupt ====
  if ((TMR1IE_bit) && (TMR1IF_bit))
   {
      Count1 ++;
       if(HC06_STATE==0) Count11++;
       if (Count1 >= DureeCycle)  // 250mS x Duree cycle=4 => 1 Sec at FOSC=8MHz
        {
         Count1=0;
         Flag_Timer1=1;
         if (Count11>0) Drapeaux.Alive=0; else  Drapeaux.Alive=1;
         Count11=0;
        Secondes ++;
       //Led_Rouge=!Led_Rouge;
        }
         //TMR1H= 0x0B;  // 3035
         //TMR1L= 0xDB;    // 62500*8*0.5 => 250000S  =0,25sec
         TMR1H= 0x3C; // Hi (15535);    // 100mS at 8MHz
         TMR1L= 0xAF; // Lo (15535);
        TMR1IF_bit = 0;
  }
  #ifdef WITH_HID_Terminal
   USB_Interrupt_Proc();                 // USB servicing is done inside the interrupt
   #endif
}
// =============  sub routines ==========


 //========== LCD 4x20 sur bus I2C ================================
  /*
  PCF8574 I2C LCD Routine
  LCD Data PCA8574: P7,P6,P5,P4
  LCD Control: P3: Back Light, P2: E-Enable, P1:RW, P0: RS
*/

 unsigned char I2C_PCF8574_Write(unsigned char Adr,unsigned char value)
{
  unsigned char S,dummy;
  I2C1_Start();
  S = I2C1_Wr( Adr );
  if(S == -1)        //check if bus collision happened
   {
     dummy = SSPBUF;        //upon bus collision detection clear the buffer,
     SSPCON1.WCOL=0;    // clear the bus collision status bit
   }
  S = I2C1_Wr(value);
  I2C1_Stop();
  return(S);
}

void LCD_CLS()
{
  Erase_Line(1);
  Erase_Line(2);
  Erase_Line(3);
  Erase_Line(4);
  LCD_putcmd(LCD_LINE1,1);
  Delay_ms(25);
}

void Erase_Line(int L)
{
 switch(L)
 {
 case 1:
  {
    LCD_putcmd(LCD_LINE1,1);
    LCD_Write_CText(mesg0);
    LCD_putcmd(LCD_LINE1,1);
    break;
  }
  case 2:
  {
    LCD_putcmd(LCD_LINE2,1);
    LCD_Write_CText(mesg0);
    LCD_putcmd(LCD_LINE2,1);
    break;
  }
  case 3:
  {
    LCD_putcmd(LCD_LINE3,1);
    LCD_Write_CText(mesg0);
    LCD_putcmd(LCD_LINE3,1);
    break;
  }
  case 4 :
  {
    LCD_putcmd(LCD_LINE4,1);
    LCD_Write_CText(mesg0);
    LCD_putcmd(LCD_LINE4,1);
    break;
  }
 }
}


void LCD_putcmd(unsigned char d,unsigned char cmdtype)
{
  unsigned char lcddata;
  char dp;
  if (GIE_bit==1)dp=1;
  if (dp==1) GIE_bit=0;
  // Put the Upper 4 bits data
  lcddata = (d & 0xF0)|LCD_BL;
  Etat=I2C_PCF8574_Write(addr,lcddata | LCD_EN);
  Delay_us(10);
  // Write Enable Pulse E: Hi -> Lo
  Etat=I2C_PCF8574_Write(addr,lcddata & ~LCD_EN);
  Delay_us(10);      // Delay 1us for 16 MHz Internal Clock
  // cmdtype = 0; One cycle write, cmdtype = 1; Two cycle writes
  if (cmdtype) 
  {
    // Put the Lower 4 bits data
    lcddata = ((d << 4) & 0xF0)|LCD_BL;
    Etat=I2C_PCF8574_Write(addr,lcddata | LCD_EN);
    Delay_us(2);    // Delay 2us for 16 MHz Internal Clock
    // Write Enable Pulse E: Hi -> Lo
    Etat=I2C_PCF8574_Write(addr,lcddata & ~LCD_EN);
    Delay_ms(5);    // Delay 1us for 16 MHz Internal Clock
    if(dp==1) GIE_bit=1;
  }
}

void LCD_putch(unsigned char d)
{
  unsigned char lcddata;
  // Put the Upper 4 bits data
  lcddata = (d & 0xF0)|LCD_BL|LCD_RS;
  Etat=I2C_PCF8574_Write(addr,lcddata | LCD_EN);
  Delay_us(5);      // Delay 2us for 16 MHz Internal Clock
  // Write Enable Pulse E: Hi -> Lo
  Etat=I2C_PCF8574_Write(addr,lcddata & ~LCD_EN);
  Delay_us(5);      // Delay 1us for 16 MHz Internal Clock
  // Put the Lower 4 bit data
  lcddata = ((d << 4) & 0xF0)|LCD_BL|LCD_RS;
  Etat=I2C_PCF8574_Write(addr,lcddata | LCD_EN);
  Delay_us(5);      // Delay 2us for 16 MHz Internal Clock
  // Write Enable Pulse E: Hi -> Lo
  Etat=I2C_PCF8574_Write(addr,lcddata & ~LCD_EN);
  Delay_us(5);      // Delay 1us for 16 MHz Internal Clock
}

void LCD_init_4x20(void)
{
  addr=LCD_ADDR;
  // Wait for more than 15 ms after VCC rises to 4.5 V
  Delay_ms(1500);
  // Send Command 0x30
  LCD_putcmd(0x30,0);
  // Wait for more than 4.1 ms
  Delay_ms(50);
  // Send Command 0x30
  LCD_putcmd(0x30,0);
  // Wait for more than 100 us
  Delay_ms(20);
  // Send Command 0x30
  LCD_putcmd(0x30,0);
    Delay_ms(20);
  // Function set: Set interface to be 4 bits long (only 1 cycle write).
  LCD_putcmd(0x20,0);
    Delay_ms(20);
  // Function set: DL=0;Interface is 4 bits, N=1; 2 Lines, F=0; 5x8 dots font)
  LCD_putcmd(0x28,1);
    Delay_ms(20);
  // Display Off: D=0; Display off, C=0; Cursor Off, B=0; Blinking Off
  LCD_putcmd(0x08,1);
    Delay_ms(20);
  // Display Clear
  LCD_putcmd(LCD_CLEAR,1);
    Delay_ms(100);
  // Entry Mode Set: I/D=1; Increament, S=0; No shift
  LCD_putcmd(0x06,1);
    Delay_ms(20);
  // Display On, Cursor Off
  LCD_putcmd(0x0C,1);
    Delay_ms(20);
}

void LCD_putsRom(const code char *s)
{int i=0;
  while((*s != 0)&& (i<20))
  {
    LCD_putch(*s);
    s++;i++;
  }
}

void LCD_puts( char *s)
{int i=0;
  while((*s != 0)&& (i<20))
  {
    LCD_putch(*s);
    s++;   i++;
  }
}

void LCD_Write_CText(const char *txt)
{
   while (*txt)
   LCD_putch(*txt++);
 }

void LCDHandler(char c) {
  LCD_putch(c);
}


void LCD_Msg_Status(const char* T)
{
// utilise la table TEXE[] !
 LCD_putcmd(LCD_LINE4,1);
 LCD_putsRom(T)   ;
}

void Retour_Cde_AT()
{
 Delay_ms(1500);
  Erase_Line(3);
  Buffer1[20]=0; // limite la taille  20 car
  LCD_puts(Buffer1);
  Delay_ms(500);
}


int  Init_BT_HC06()        // en aveugle,sans test reponse
{
  unsigned int Step,res ;
  Step=0;
  res=0;
  Erase_Line(3);
  Erase_Line(4);
  LCD_putcmd(LCD_LINE1,1);
  LCD_putsRom("1ere Init (optionel)");

  Raz_COM();
  // timer1 as timeout connection
  Secondes=0;
  Init_Timer1();
  LCD_putcmd(LCD_LINE2,1)  ;
  LCD_putsRom("Envoi Cde AT (10sec)");
 do
 {  
     Raz_COM();
     UART1_Write_CText("AT");
     //Delay_ms(500);
     //Erase_Line(3);
     //Buffer1[20]=0; // limite la taille  20 car
     //LCD_puts(Buffer1);
     Retour_Cde_AT();
     p1= strstr(Buffer1,"OK");
     if (p1>0)
     {
        Step=1;
        break;
      }
  }while(Secondes<10);
  PIE1.TMR1IE=0;  //Disable interrupt TMR1
  TMR1ON_bit=0;   // stop timer1
  Flag_Timer1=0;
  Secondes=0;
  Erase_Line(3);
  LCD_putcmd(LCD_LINE2,1) ;
  //           12345678901234567890
  LCD_putsRom(" AT+PIN1234         ");
  Raz_COM();
  UART1_Write_CText("AT+PIN1234");
  Retour_Cde_AT();
  p1= strstr(Buffer1,"OK");
  if (p1>0) Step++;
  
  Erase_Line(3);
  LCD_putcmd(LCD_LINE2,1) ;
  LCD_putsRom(" AT+NAMEHC06-2186-J ");
  Raz_COM();
  UART1_Write_CText("AT+NAMEHC06-2187-J");  //"AT+NAME"BT_NAME);
  Retour_Cde_AT();
  p1=strstr(Buffer1,"OK");
  if(p1>0) Step++;

  Erase_Line(3);
  LCD_putcmd(LCD_LINE2,1) ;
  LCD_putsRom("   AT+VERSION       ");
  Raz_COM();
  UART1_Write_CText("AT+VERSION"); Delay_ms(1500);
  if(strstr(Buffer1,"OK")) Step++;
  Retour_Cde_AT();
  Delay_ms(1000);
  Raz_COM();
  LCD_CLS();
  Delay_ms(100);
  LCD_putcmd(LCD_LINE1,1);  Delay_ms(50);
  LCD_putsRom("Test si Link BT OK ?");
    //         12345678901234567890
  strConstRamCpy(CRam1,"BT HC06 STATE =     ");
  Secondes=0;
  do
    {
       Init_Timer1();
       while (Flag_Timer1==0)
       *(CRam1+17)=Drapeaux.Alive+48;
        LCD_putcmd(LCD_LINE2,1);
        LCD_puts(CRam1);
        Delay_ms(500);
        if(Drapeaux.Alive==1) break;
    }
    while(Secondes<10);  // Timeout 3mn
    Delay_ms(500);
    if(Drapeaux.Alive==1) Step ++; else Step=0;
    PIE1.TMR1IE=0;  //Disable interrupt TMR1
    TMR1ON_bit=0;   // stop timer1
    Flag_Timer1=0;
    Secondes=0;
  return Step  ;
 }




char * VirguleToAscii(float chiffreDeci)     // 298 bytes
{
unsigned int i;
unsigned int e=0;
unsigned int d=0;
char pointeurTab[5];
e=(int)chiffreDeci;                                 // partie entire
d=(int)((chiffreDeci-(float)e)*100.0);                  // partie dcimale(2 chiffres)
pointeurTab[0]=(char)((e/100)+0x30);                  // partie entiere de 999 a 0
e=e%100;
pointeurTab[1]=(char)((e/10)+0x30);
pointeurTab[2]=(char)((e%10)+0x30);
for (i=0;i<2;i++)  // test avant la virgule
 { if (pointeurTab[i]!='0') break; else pointeurTab[i]=' ';
 }
pointeurTab[3]=0x2C;                              // j'aime bien la virgule :-)
pointeurTab[4]=(char)((d/10)+0x30);                     // partie decimale de 99 a 0
pointeurTab[5]=(char)((d%10)+0x30);
return pointeurTab;
}

void CRLF()
{
  UART1_Write(CR);
  UART1_Write(LF);
 }


void Init_Hardware() // 18F2550
 {
   // ATTENTION a l'ordre des canaux ANALOGIQUES !!!
   TRISA = 0xFF ;   // PORTA is RA0= analog input  RA1.5=Digital input
   // Dsactiver le comparateur sur RA0  RA3
   CMCON  = 0x07;  // Disable comparators
   Led_Rouge_Direction=0;       // RA1 = Led Jaune sur carte StartUSB
   HC06_Enable_Direction=0;
   //
   PORTB = 0xFF;
   TRISB = 0xFF;
   HC06_STATE_Direction=1;   // RB2
   TRISB0_bit=1;   // must be configure as input for I2C
   TRISB1_bit=1;    // must be configure as input for I2C
   Led_Verte_Direction=0;
   INTCON2.RBPU=1;      // enable Pull-up
   //
  PORTC = 0xFF;          // set PORTC to $FF
  TRISC = 0xFF;    // all input  for RC6 et RC7 , bien que RC6 soit prevu comme Sortie TX
  //  To use pins RC4 and RC5 asdi  gital inputs, the USB module must be
  // disabled (UCON<3> = 0) and the on-chipUS B transceiver must be disabled  (UCFG<3> = 1).
 }

// --- Copie le texte depuis ROM vers RAM
void strConstRamCpy(unsigned char *dest, const code char *source)
 {
  while (*source)*dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}


void UART1_Write_CText(const char *T1)
{
   while (*T1)   UART1_Write(*T1++);
 }
 
void Init_Timer1(void)
 {
  T1CON=0;
 // T1CKPS1_bit=1;  //prescal select=11 => 1/8  65535-3035= -> 62 500 * 8 *7/8 =>250ms at 8Mhz
//  T1CKPS0_bit=1;
 // TMR1H= 0x0B; // Hi (3035);
 // TMR1L= 0xDB; // Lo (3035);
   T1CKPS1_bit=1;  //prescal select=10 => 1/4  65535-15535=50 000  =>50 000 * 4 *4/8=> 100ms at 8Mhz
   T1CKPS0_bit=0;
   TMR1H= 0x3C; // Hi (15535);
   TMR1L= 0xAF; // Lo (15535);
  // T1GCON=0;
  Flag_Timer1=0;
  TMR1IP_bit=1;
  PIR1.TMR1IF=0;     // Reset Timer1 Flag
  PIE1.TMR1IE=1;  //Enable interrupt TMR1
  TMR1ON_bit=1;
}

void Init_ADC()
{
   ADCON0 = 0x00;// select channel 0 (AN0)
   ADCON1 = 0;
   ADCON2 = 0;
   ADCON1.VCFG1=0;    // VREF- = VSS=0V
   ADCON1.VCFG0=0;  // VREF+ = VDD=+5V
   ADCON1.PCFG3=1;
   ADCON1.PCFG2=1;
   ADCON1.PCFG1=1;
   ADCON1.PCFG0=0;
   ADCON0.ADON = 1;//Enable A/D module
   //ADCON2 setup: Right justified, Tacq=16Tad, Tad=2*Tosc (or Fosc/2)
   ADCON2.ADFM=1; // right justified
   ADCON2.ACQT2=1;  // 111 => 20 Tad
   ADCON2.ACQT1=1;
   ADCON2.ACQT0=1;
   ADCON2.ADCS2=1;  // FOSC /64
   ADCON2.ADCS1=1;
   ADCON2.ADCS0=1;
}

unsigned int  Mesure_ADC( int j)
{ 
  unsigned int M;
  // enlever le strap sur carte STARTUP USB pour ADC RA1
  //ADCON0.ADON=1;
  ADCON0=1 + (j<<2);   // ADON=1 et choix de canal
  Delay_ms(1);
  ADCON0.GO_DONE = 1;//Start A/D Conversion
  _asm NOP;
  while(ADCON0.GO_DONE ==1);//Loop here until A/D conversion completes
  M = (ADRESH <<8) + ADRESL;
  return M;
}

void Raz_COM()
{
  CptFO=0;CptFE=0;
  for (i=0;i<MAXLEN1;i++)  Buffer1[i]=0;
  Flag_Buffer1 = 0;
  Index1=0;
  i1=0;
  c1=0;
  RCIE_bit=1;
}


void UART1_Write_String( char *s)
{
 while (*s)
 {
 UART1_Write(*s++);
 Delay_ms(1);  // maybe can be less
 }
}

void main()
 {
    #ifdef OSCILLATEUR_INTERNE
 // Configurer la frquence 8MHZ pour 9600 bauds
     OSCTUNE =0;   //=> com OK at 19200
     // OSCTUNE = 0b00001000; // => very bad com at 19200
     //OSCCON = 0b01111110;
     // System Clock Select bits
     OSCCON.SCS1=1;     //Internal oscillator
     OSCCON.SCS0=0;
     //IRCF2:IRCF0: Internal Oscillator Frequency Select bits = 111    8Mhz
     OSCCON.IRCF2=1;
     OSCCON.IRCF1=1;
     OSCCON.IRCF0=1;
     Delay_ms(100);
     #endif
 
  OUT_RS232;

  Init_Hardware();
  // Initialize variables
  Drapeaux.Toggle=0;
  HC06_Enable=0;
  /*
  // test -optionnel) des leds
  Led_Rouge=1;
  Led_Verte=0;
  for (i=0;i<4;i++)
  {
  Led_Rouge=!Led_Rouge;
  Led_Verte=!Led_Verte;
   Delay_ms(1000);
  }
  */
  Led_Verte=0;
  Secondes=0;
  Led_Rouge=0;

  UART1_Init(9600);     // 9600 bauds   8MHz
  c1=0;
  UART1_Write(CLS);
  Delay_ms(500);
  CRLF();

  Init_ADC();
  
  UART1_Write_CText(RS_Str[0]);
  CRLF();
  Delay_ms(500);
  UART1_Write_CText(RS_Str[1]); // menu
  CRLF();
  
  HC06_Enable=1;
  Delay_ms(100);
  

#ifdef With_LCD_I2C
  I2C1_Init(100000);
  Delay_ms(100);
  LCD_init_4x20();
  Delay_ms(100);
  Erase_Line(1);
  LCD_Write_CText("18F2550 FOSC 8MHz   ");
  Erase_Line(2);
  LCD_Write_CText(mesg0);
  Delay_ms(1000);
  Erase_Line(3);
  LCD_Write_CText("HC06 BT +UART1 + HID");
  Delay_ms(1000);
  LCD_Msg_Status("Version 23/01/2016   ");
  Delay_ms(1000);
#endif

  
    // init pour interruptions UART ----
  IPR1.RCIP=1;  //  High priority
  RCON.IPEN = 1;     // enaable Low & High interrupt priority model.
  PIE1.RCIE = 1;    /// enable interrupt reception
  INTCON.PEIE = 1;   // autorisation des IT des priphriques
  INTCON.GIE = 1 ; // Enable IT
  Drapeaux.Toggle=0;

  k=Init_BT_HC06()  ;
  LCD_CLS();
  LCD_putcmd(LCD_LINE1,1);  Delay_ms(25);
  if(k>0)
  {
     UART1_Write_CText("\r\n Module BT connect.OK\r\n");
     LCD_putsRom("HC06-2187-J Connect");
  }
  else
   {
     UART1_Write_CText("\r\nPB sur Init Module BT ou Deja connect\r\n");
     LCD_putsRom("PB..connection HC06");
   }

  LCD_putcmd(LCD_LINE2,1);   Delay_ms(25);
  LCD_putsRom("Init Timer1 1seconde");

  Init_Timer1(); // 1 sec
  while (Flag_Timer1==0) ;  // test immediat du timer
  Init_Timer1(); // 1 sec
  
  Raz_COM();
  Nb=0;
  //Drapeaux.Toggle=1;
  LCD_CLS();
  Erase_Line(1);
          //   12345678901234567890
  LCD_putsRom("Dialogue BlueTooth  ");
  
    #ifdef WITH_HID_Terminal
    // ....
    // .. To DO
    // ...
    #endif
  
  //=== boucle principale ==================
  while(1)
  {
   if (Flag_Buffer1==1)
    {
     //UART1_Write_CText("Reception : ");UART1_Write_Text(&Buffer1[0]);CRLF();
     // comparaison avec le contenu global de buffer1
     // strstr retourne un pointeur

     LCD_putcmd(LCD_LINE1,1);   Delay_ms(25);
     LCD_putsRom("Reception HC06 BT : ");
     Erase_Line(2);
     strncpy(CRam1,Buffer1,19);
     LCD_puts(CRam1);
     if(strstr(Buffer1,"RED_ON")>0) Led_Rouge=1;
     if(strstr(Buffer1,"RED_OFF")>0) Led_Rouge=0;
     // comparaison strictement exacte
     // strncmp retourne un entier
     if(strncmp(Buffer1,"GREEN_ON",8)==0) Led_Verte=1;
     if(strncmp(Buffer1,"GREEN_OFF",9)==0) Led_Verte=0;
     if(strstr(Buffer1,"TOGGLE")>0) 
        {
          Drapeaux.Toggle=!Drapeaux.Toggle;
          if (Drapeaux.Toggle==1) Erase_Line(4);
        }
     if(strstr(Buffer1,"HELP")>0)
     {
        UART1_Write_CText("Cdes= RED_ON, RED_OFF,GREEN_ON, TOGGLE(ADC mesure),HELP \r\n");
        LCD_CLS();
        LCD_putcmd(LCD_LINE1,1);  Delay_ms(25);
        //              12345678901234567890
        LCD_putsRom ("Cdes: RED_ON,RED_OFF");
        LCD_putcmd(LCD_LINE2,1);  Delay_ms(25);
        LCD_putsRom ("GREEN_ON , GREEN_OFF");
        LCD_putcmd(LCD_LINE3,1);  Delay_ms(25);
        LCD_putsRom ("TOGGLE = ADC on/off ");
        LCD_putcmd(LCD_LINE4,1);  Delay_ms(25);
        LCD_putsRom ("HELP  = this help   ");
        Delay_ms(1000);
         // ......
      }
      Raz_COM();
    } // if Flag_buffer1 , reception UART

    // ---  traitement de la commande togle "T" -----
    if(Drapeaux.Toggle==1)
    {

     // to do ....
    }
    // si erreurs de communication
    if ((CptFE>10)  || (CptFO>10) )
    {
      UART1_Write_CText(RS_Str[2]);
      UART1_Write(TAB); 
      WordToStr(CptFE,CRam1);UART1_Write_Text(CRam1);
      WordToStr(CptFO,CRam1);UART1_Write_Text(CRam1);
      CRLF();
      CptFE=0; CptFO=0;
      Raz_COM();
      Delay_ms(500);
    }
    Nb++;
    if  ( (  Nb % 10 )==0 )
    {
      if (Drapeaux.Alive==0)
        {
         LCD_Msg_Status(" PB liaison B.T.    ");
        }
    }
     else
      {  // vers LCD
         txt=&Texte[0];
         strConstRamCpy(txt,"LR=.;LV=.;TO=.;LI=.;");
         *(txt+3)= ((PORTA & 0x02) >>1) + 48 ;
         #ifdef With_LCD_I2C
         *(txt+8)=((PORTB & 0x10) >>4) + 48 ;
          #else
         *(txt+8)=((PORTB & 0x02) >>1) + 48 ;
         #endif
         *(txt+13)= (Drapeaux.Toggle + 48) ;
         *(txt+18)= (Drapeaux.Alive + 48) ;
         LCD_putcmd(LCD_LINE3,1);  Delay_ms(25);
         LCD_puts(txt);
         
         /* specifique  vers UART
         txt=&Texte[0];
         strConstRamCpy(txt,"LedR=.;LedV=.;Toggle=.;Link=.;");
         *(txt+5)=((PORTA & 0x02) >>1) + 48 ;
         #ifdef  With_LCD_I2C
         *(txt+12)=((PORTB & 0x10) >>4) + 48 ;     // led sur RB4
         #else
         *(txt+12)=((PORTB & 0x02) >>1) + 48 ;    // led sur RB1
         #endif
         *(txt+21)= (Drapeaux.Toggle + 48) ;
         *(txt+28)= (Drapeaux.Alive + 48) ;
         */


         Ch=0;                        // numero de channel ADC
         EA0=Mesure_ADC(Ch) ;             // lecture  chanel RA0 et envoi sur UART
         strConstRamCpy(CRam1,"EA0= ");
         k=strlen(CRam1);
         WordToStr(M,CRam1+k);

         k=strlen(CRam1);
         strcat(CRam1+k,";");
         k=strlen(CRam1);
         f1=(float) EA0 * 0.00488;
         strcat(CRam1+k,VirguleToAscii(f1));
         LCD_putcmd(LCD_LINE4,1);  Delay_ms(25);
         LCD_puts(CRam1); LCD_putch(';');
         k=strlen(txt);
          strcat(txt+k,CRam1);
         //UART1_Write_Text(VirguleToAscii(f1));
         UART1_Write_Text(txt);
         UART1_Write('V');
         UART1_Write(';');
         CRLF();
     } // if Nb%10
     
        // attente synchro timer1 1 sec
   while (Flag_Timer1==0) ;
   Init_Timer1(); // 1 sec
   }  // while
 }

/*

 18F2550_Startup_USB_test_BlueTooth_160116.c

Cdes= RED_ON, RED_OFF,GREE_ON, TOGGLE (ADC mesure)

AT
PB sur Init Module BT
Status LedR= 0  LedV= 0   Toggle=1.
    4-EA0=  997   4,86V
    5-EA0=  412   2,01V
    6-EA0=  289   1,41V
    7-EA0=  202   0,98V
    8-EA0=  152   0,74V
    9-EA0=  125   0,60V
   10-EA0=  108   0,52V
   11-EA0=  100   0,48V
Status LedR= 0  LedV= 0   Toggle=0.
Status LedR= 1  LedV= 0   Toggle=0.
Status LedR= 0  LedV= 0   Toggle=0.
Active
Active

 ==================
 void fltToa (float x, unsigned char *str,char precision) 
   // 972 bytes   Data     359 bytes used ,   ROM  7783 bytes used
char * VirguleToAscii(float chiffreDeci)  
// 298 bytes                          Data     349 bytes used  ,  ROM  6439 bytes used
===================






0 1 mikroCPIC1618.exe -MSF -DBG -pP18F2550 -UICD -C -O11111014 -fo8 -N"
C:\_MikroC\_MesProjets_MikroC\_18F2550_BT\18F2550_StartUSB_test_BlueTooh.mcppi" -SP"
C:\_MikroC\mikroC PRO for PIC\Defs\" -SP"C:\_MikroC\mikroC PRO for PIC\uses\P18\" -SP"
C:\_MikroC\_MesProjets_MikroC\_18F2550_BT\" -SP"C:\_MikroC\_MesProjets_MikroC\_18F2550_StartUSB\" -SP"
C:\_MikroC\_MesProjets_MikroC\common\" "18F2550_Startup_USB_test_BlueTooth_160114.c" "
__Lib_Math.mcl" "
__Lib_MathDouble.mcl" "
__Lib_System.mcl" "
__Lib_Delays.mcl" "
__Lib_CType.mcl" "
__Lib_CString.mcl" "
__Lib_CStdlib.mcl" "
__Lib_Conversions.mcl" "
__Lib_EEPROM_256.mcl" "
__Lib_UART_c67.mcl"
0 1139 Available RAM: 2027 [bytes], Available ROM: 32768 [bytes]
0 122 Compilation Started 18F2550_Startup_USB_test_BlueTooth_160114.c
0 1004 interrupt handler (InterruptVectorHigh at 0x0008) 18F2550_Startup_USB_test_BlueTooth_160114.c
471 1509 Generated baud rate is 9615 bps (error = 0.16 percent) 18F2550_Startup_USB_test_BlueTooth_160114.c
584 123 Compiled Successfully 18F2550_Startup_USB_test_BlueTooth_160114.c
237 1164 Variable 'res' has been eliminated by optimizer 18F2550_Startup_USB_test_BlueTooth_160114.c
0 127 All files Compiled in 94 ms
0 1144 Used RAM (bytes): 324 (16%)  Free RAM (bytes): 1703 (84%) Used RAM (bytes): 324 (16%)  Free RAM (bytes): 1703 (84%)
0 1144 Used ROM (bytes): 4612 (14%)  Free ROM (bytes): 28156 (86%) Used ROM (bytes): 4612 (14%)  Free ROM (bytes): 28156 (86%)
0 125 Project Linked Successfully 18F2550_StartUSB_test_BlueTooh.mcppi
0 128 Linked in 47 ms
0 129 Project '18F2550_StartUSB_test_BlueTooh.mcppi' completed: 172 ms
0 103 Finished successfully: 15 janv. 2016, 15:58:52 18F2550_StartUSB_test_BlueTooh.mcppi

*/