#line 1 "C:/_MikroC/_MesProjets_MikroC/_18F2550_BT_HC06/18F2550_Startup_USB_test_BlueTooth_LCD_160124.c"
#line 1 "c:/_mikroc/mikroc pro for pic/include/built_in.h"
#line 125 "C:/_MikroC/_MesProjets_MikroC/_18F2550_BT_HC06/18F2550_Startup_USB_test_BlueTooth_LCD_160124.c"
sbit Led_Rouge at LATA1_bit;

sbit Led_Rouge_Direction at TRISA1_bit;


sbit Led_Verte_Direction at TRISB4_bit;
sbit Led_Verte at LATB4_bit;
#line 139 "C:/_MikroC/_MesProjets_MikroC/_18F2550_BT_HC06/18F2550_Startup_USB_test_BlueTooth_LCD_160124.c"
sbit HC06_Enable at LATA4_bit;
sbit HC06_Enable_Direction at TRISA4_bit;
sbit HC06_STATE at PORTB.B2;
sbit HC06_STATE_Direction at TRISB2_bit;
#line 168 "C:/_MikroC/_MesProjets_MikroC/_18F2550_BT_HC06/18F2550_Startup_USB_test_BlueTooth_LCD_160124.c"
const char chaine0[]="18F2550_Startup_USB_test_BlueTooth_LCD_" "160124" ".c\r\n";
const char chaine1[]="Cdes= RED_ON, RED_OFF,GREE_ON, TOGGLE (ADC mesure) \r\n";
const char chaine2[]=" Error de COM : ";
const char mesg0[]="                    ";

const char *RS_Str[]={chaine0,chaine1,chaine2};
#line 1 "c:/_mikroc/_mesprojets_mikroc/_18f2550_bt_hc06/usbdescriptor_startusb_18f2550.c"
const unsigned int USB_VENDOR_ID = 0x1234;
const unsigned int USB_PRODUCT_ID = 0x1234;
const char USB_SELF_POWER = 0x80;
const char USB_MAX_POWER = 50;
const char HID_INPUT_REPORT_BYTES = 64;
const char HID_OUTPUT_REPORT_BYTES = 64;
const char USB_TRANSFER_TYPE = 0x03;
const char EP_IN_INTERVAL = 1;
const char EP_OUT_INTERVAL = 1;

const char USB_INTERRUPT = 1;
const char USB_HID_EP = 1;
const char USB_HID_RPT_SIZE = 33;


const struct {
 char bLength;
 char bDescriptorType;
 unsigned int bcdUSB;
 char bDeviceClass;
 char bDeviceSubClass;
 char bDeviceProtocol;
 char bMaxPacketSize0;
 unsigned int idVendor;
 unsigned int idProduct;
 unsigned int bcdDevice;
 char iManufacturer;
 char iProduct;
 char iSerialNumber;
 char bNumConfigurations;
} device_dsc = {
 0x12,
 0x01,
 0x0200,
 0x00,
 0x00,
 0x00,
 8,
 USB_VENDOR_ID,
 USB_PRODUCT_ID,
 0x0001,
 0x01,
 0x02,
 0x00,
 0x01
 };


const char configDescriptor1[]= {

 0x09,
 0x02,
 0x29,0x00,
 1,
 1,
 0,
 USB_SELF_POWER,
 USB_MAX_POWER,


 0x09,
 0x04,
 0,
 0,
 2,
 0x03,
 0,
 0,
 0,


 0x09,
 0x21,
 0x01,0x01,
 0x00,
 1,
 0x22,
 USB_HID_RPT_SIZE,0x00,


 0x07,
 0x05,
 USB_HID_EP | 0x80,
 USB_TRANSFER_TYPE,
 0x40,0x00,
 EP_IN_INTERVAL,


 0x07,
 0x05,
 USB_HID_EP,
 USB_TRANSFER_TYPE,
 0x40,0x00,
 EP_OUT_INTERVAL
};

const struct {
 char report[USB_HID_RPT_SIZE];
}hid_rpt_desc =
 {
 {0x06, 0x00, 0xFF,
 0x09, 0x01,
 0xA1, 0x01,

 0x19, 0x01,
 0x29, 0x40,
 0x15, 0x00,
 0x26, 0xFF, 0x00,
 0x75, 0x08,
 0x95, HID_INPUT_REPORT_BYTES,
 0x81, 0x02,

 0x19, 0x01,
 0x29, 0x40,
 0x75, 0x08,
 0x95, HID_OUTPUT_REPORT_BYTES,
 0x91, 0x02,
 0xC0}
 };


const struct {
 char bLength;
 char bDscType;
 unsigned int string[1];
 } strd1 = {
 4,
 0x03,
 {0x0409}
 };



const struct{
 char bLength;
 char bDscType;
 unsigned int string[16];
 }strd2={
 34,
 0x03,
 {'M','i','k','r','o','e','l','e','k','t','r','o','n','i','k','a'}
 };


const struct{
 char bLength;
 char bDscType;
 unsigned int string[15];
}strd3={
 32,
 0x03,
 {'U','S','B',' ','H','I','D',' ','L','i','b','r','a','r','y'}
 };


const char* USB_config_dsc_ptr[1];


const char* USB_string_dsc_ptr[3];

void USB_Init_Desc(){
 USB_config_dsc_ptr[0] = &configDescriptor1;
 USB_string_dsc_ptr[0] = (const char*)&strd1;
 USB_string_dsc_ptr[1] = (const char*)&strd2;
 USB_string_dsc_ptr[2] = (const char*)&strd3;
}
#line 177 "C:/_MikroC/_MesProjets_MikroC/_18F2550_BT_HC06/18F2550_Startup_USB_test_BlueTooth_LCD_160124.c"
unsigned char readbuff[64] absolute 0x500;
unsigned char writebuff[64] absolute 0x540;



unsigned char Buffer1[ 80 ];
volatile char c1;
volatile int Flag_Buffer1;
volatile int Index1;
volatile unsigned int i1;
volatile int CptFO,CptFE;
char *p1;

char Texte[ 80 ]="\0";
char *txt;
 unsigned char  CRam1[32];

volatile unsigned int Secondes;
volatile int Flag_Timer1=0;

unsigned int i,j,k;
unsigned int M;
unsigned long L;
float f1;
unsigned int Nb;
unsigned int Ch, EAx,EA0;

int Etat,addr;


volatile struct chbits {
 unsigned Empty:1;
 unsigned Lcd:1;
 unsigned Elligible:1;
 unsigned Toggle:1;
 unsigned Blc:1;
 unsigned standby:1;
 unsigned Fill:1;
 unsigned Alive:1;
 }Drapeaux ;




void strConstRamCpy(unsigned char *dest, const code char *source) ;
void UART1_Write_String( char *s);
void UART1_Write_CTextt(const char *s);
void CRLF(void);
void Write_Word_(unsigned int M,char Sign);

char * VirguleToAscii(float chiffreDeci);


void Save_Msg_To_EEPROM(unsigned int * adrx, unsigned char *ptr1);
void PrintOut_Eeprom_Msg(unsigned int *PtrE);
void UART1_Write_CText(const code char *T1) ;

void Init_Hardware(void);
void Init_Timer1(void);
void Init_ADC();
unsigned int Mesure_ADC(int Channel);
void Raz_COM(void) ;
int Init_BT_HC06(void);


unsigned char I2C_PCF8574_Write(unsigned char Adr,unsigned char value);
void LCD_init_4x20(void);
void LCD_putcmd(unsigned char d,unsigned char cmdtype);
void LCD_putch(unsigned char d);
void LCD_puts(char *s);
void LCD_putsRom(code char *s);


void LCD_CLS(void);
void LCD_Msg_Status(const char* T);
void LCD_Write_CText(const char *txt) ;
void LCDHandler(char c) ;
void Erase_Line(int L);


void void InterruptVectorHigh() iv 0x0008 ics ICS_AUTO
 {
 static unsigned int Count1;
 static unsigned int Count11;
 if ( (RCIE_bit) && ( RCIF_bit))
 {


 if (RCSTA.OERR==1)
 {
 RCSTA.CREN = 0 ;
 _asm nop ;
 _asm nop;
 RCSTA.CREN = 1 ;
 CptFO++;
 }
 if(RCSTA.FERR==1 )
 {
 CptFE++;
 c1 = RCREG;

 }

 c1= RCREG;
 if(i1>= 80 )
 {
 Flag_Buffer1=2;
 RCIE_bit=0;
 i1=0;
 Index1--;
 c1=0;
 }
 if (c1== 13 )
 {

 Flag_Buffer1=1;
 Buffer1[i1]=0;
 Index1=i1;
 i1=0;
 }
 else
 {
 Buffer1[i1]=c1;
 Index1=i1;
 i1++;

 }
 }


 if ((TMR1IE_bit) && (TMR1IF_bit))
 {
 Count1 ++;
 if(HC06_STATE==0) Count11++;
 if (Count1 >=  15 )
 {
 Count1=0;
 Flag_Timer1=1;
 if (Count11>0) Drapeaux.Alive=0; else Drapeaux.Alive=1;
 Count11=0;
 Secondes ++;

 }


 TMR1H= 0x3C;
 TMR1L= 0xAF;
 TMR1IF_bit = 0;
 }

 USB_Interrupt_Proc();

}
#line 340 "C:/_MikroC/_MesProjets_MikroC/_18F2550_BT_HC06/18F2550_Startup_USB_test_BlueTooth_LCD_160124.c"
 unsigned char I2C_PCF8574_Write(unsigned char Adr,unsigned char value)
{
 unsigned char S,dummy;
 I2C1_Start();
 S = I2C1_Wr( Adr );
 if(S == -1)
 {
 dummy = SSPBUF;
 SSPCON1.WCOL=0;
 }
 S = I2C1_Wr(value);
 I2C1_Stop();
 return(S);
}

void LCD_CLS()
{
 Erase_Line(1);
 Erase_Line(2);
 Erase_Line(3);
 Erase_Line(4);
 LCD_putcmd( 0x80 ,1);
 Delay_ms(25);
}

void Erase_Line(int L)
{
 switch(L)
 {
 case 1:
 {
 LCD_putcmd( 0x80 ,1);
 LCD_Write_CText(mesg0);
 LCD_putcmd( 0x80 ,1);
 break;
 }
 case 2:
 {
 LCD_putcmd( 0xC0 ,1);
 LCD_Write_CText(mesg0);
 LCD_putcmd( 0xC0 ,1);
 break;
 }
 case 3:
 {
 LCD_putcmd( 0x94 ,1);
 LCD_Write_CText(mesg0);
 LCD_putcmd( 0x94 ,1);
 break;
 }
 case 4 :
 {
 LCD_putcmd( 0xD4 ,1);
 LCD_Write_CText(mesg0);
 LCD_putcmd( 0xD4 ,1);
 break;
 }
 }
}


void LCD_putcmd(unsigned char d,unsigned char cmdtype)
{
 unsigned char lcddata;
 char dp;
 if (GIE_bit==1)dp=1;
 if (dp==1) GIE_bit=0;

 lcddata = (d & 0xF0)| 0x08 ;
 Etat=I2C_PCF8574_Write(addr,lcddata |  0x04 );
 Delay_us(10);

 Etat=I2C_PCF8574_Write(addr,lcddata & ~ 0x04 );
 Delay_us(10);

 if (cmdtype)
 {

 lcddata = ((d << 4) & 0xF0)| 0x08 ;
 Etat=I2C_PCF8574_Write(addr,lcddata |  0x04 );
 Delay_us(2);

 Etat=I2C_PCF8574_Write(addr,lcddata & ~ 0x04 );
 Delay_ms(5);
 if(dp==1) GIE_bit=1;
 }
}

void LCD_putch(unsigned char d)
{
 unsigned char lcddata;

 lcddata = (d & 0xF0)| 0x08 | 0x01 ;
 Etat=I2C_PCF8574_Write(addr,lcddata |  0x04 );
 Delay_us(5);

 Etat=I2C_PCF8574_Write(addr,lcddata & ~ 0x04 );
 Delay_us(5);

 lcddata = ((d << 4) & 0xF0)| 0x08 | 0x01 ;
 Etat=I2C_PCF8574_Write(addr,lcddata |  0x04 );
 Delay_us(5);

 Etat=I2C_PCF8574_Write(addr,lcddata & ~ 0x04 );
 Delay_us(5);
}

void LCD_init_4x20(void)
{
 addr= 0x4E ;

 Delay_ms(1500);

 LCD_putcmd(0x30,0);

 Delay_ms(50);

 LCD_putcmd(0x30,0);

 Delay_ms(20);

 LCD_putcmd(0x30,0);
 Delay_ms(20);

 LCD_putcmd(0x20,0);
 Delay_ms(20);

 LCD_putcmd(0x28,1);
 Delay_ms(20);

 LCD_putcmd(0x08,1);
 Delay_ms(20);

 LCD_putcmd( 0x01 ,1);
 Delay_ms(100);

 LCD_putcmd(0x06,1);
 Delay_ms(20);

 LCD_putcmd(0x0C,1);
 Delay_ms(20);
}

void LCD_putsRom(const code char *s)
{int i=0;
 while((*s != 0)&& (i<20))
 {
 LCD_putch(*s);
 s++;i++;
 }
}

void LCD_puts( char *s)
{int i=0;
 while((*s != 0)&& (i<20))
 {
 LCD_putch(*s);
 s++; i++;
 }
}

void LCD_Write_CText(const char *txt)
{
 while (*txt)
 LCD_putch(*txt++);
 }

void LCDHandler(char c) {
 LCD_putch(c);
}


void LCD_Msg_Status(const char* T)
{

 LCD_putcmd( 0xD4 ,1);
 LCD_putsRom(T) ;
}

void Retour_Cde_AT()
{
 Delay_ms(1500);
 Erase_Line(3);
 Buffer1[20]=0;
 LCD_puts(Buffer1);
 Delay_ms(500);
}


int Init_BT_HC06()
{
 unsigned int Step,res ;
 Step=0;
 res=0;
 Erase_Line(3);
 Erase_Line(4);
 LCD_putcmd( 0x80 ,1);
 LCD_putsRom("1ere Init (optionel)");

 Raz_COM();

 Secondes=0;
 Init_Timer1();
 LCD_putcmd( 0xC0 ,1) ;
 LCD_putsRom("Envoi Cde AT (10sec)");
 do
 {
 Raz_COM();
 UART1_Write_CText("AT");




 Retour_Cde_AT();
 p1= strstr(Buffer1,"OK");
 if (p1>0)
 {
 Step=1;
 break;
 }
 }while(Secondes<10);
 PIE1.TMR1IE=0;
 TMR1ON_bit=0;
 Flag_Timer1=0;
 Secondes=0;
 Erase_Line(3);
 LCD_putcmd( 0xC0 ,1) ;

 LCD_putsRom(" AT+PIN1234         ");
 Raz_COM();
 UART1_Write_CText("AT+PIN1234");
 Retour_Cde_AT();
 p1= strstr(Buffer1,"OK");
 if (p1>0) Step++;

 Erase_Line(3);
 LCD_putcmd( 0xC0 ,1) ;
 LCD_putsRom(" AT+NAMEHC06-2186-J ");
 Raz_COM();
 UART1_Write_CText("AT+NAMEHC06-2187-J");
 Retour_Cde_AT();
 p1=strstr(Buffer1,"OK");
 if(p1>0) Step++;

 Erase_Line(3);
 LCD_putcmd( 0xC0 ,1) ;
 LCD_putsRom("   AT+VERSION       ");
 Raz_COM();
 UART1_Write_CText("AT+VERSION"); Delay_ms(1500);
 if(strstr(Buffer1,"OK")) Step++;
 Retour_Cde_AT();
 Delay_ms(1000);
 Raz_COM();
 LCD_CLS();
 Delay_ms(100);
 LCD_putcmd( 0x80 ,1); Delay_ms(50);
 LCD_putsRom("Test si Link BT OK ?");

 strConstRamCpy(CRam1,"BT HC06 STATE =     ");
 Secondes=0;
 do
 {
 Init_Timer1();
 while (Flag_Timer1==0)
 *(CRam1+17)=Drapeaux.Alive+48;
 LCD_putcmd( 0xC0 ,1);
 LCD_puts(CRam1);
 Delay_ms(500);
 if(Drapeaux.Alive==1) break;
 }
 while(Secondes<10);
 Delay_ms(500);
 if(Drapeaux.Alive==1) Step ++; else Step=0;
 PIE1.TMR1IE=0;
 TMR1ON_bit=0;
 Flag_Timer1=0;
 Secondes=0;
 return Step ;
 }




char * VirguleToAscii(float chiffreDeci)
{
unsigned int i;
unsigned int e=0;
unsigned int d=0;
char pointeurTab[5];
e=(int)chiffreDeci;
d=(int)((chiffreDeci-(float)e)*100.0);
pointeurTab[0]=(char)((e/100)+0x30);
e=e%100;
pointeurTab[1]=(char)((e/10)+0x30);
pointeurTab[2]=(char)((e%10)+0x30);
for (i=0;i<2;i++)
 { if (pointeurTab[i]!='0') break; else pointeurTab[i]=' ';
 }
pointeurTab[3]=0x2C;
pointeurTab[4]=(char)((d/10)+0x30);
pointeurTab[5]=(char)((d%10)+0x30);
return pointeurTab;
}

void CRLF()
{
 UART1_Write( 13 );
 UART1_Write( 10 );
 }


void Init_Hardware()
 {

 TRISA = 0xFF ;

 CMCON = 0x07;
 Led_Rouge_Direction=0;
 HC06_Enable_Direction=0;

 PORTB = 0xFF;
 TRISB = 0xFF;
 HC06_STATE_Direction=1;
 TRISB0_bit=1;
 TRISB1_bit=1;
 Led_Verte_Direction=0;
 INTCON2.RBPU=1;

 PORTC = 0xFF;
 TRISC = 0xFF;


 }


void strConstRamCpy(unsigned char *dest, const code char *source)
 {
 while (*source)*dest++ = *source++ ;
 *dest = 0 ;
}


void UART1_Write_CText(const char *T1)
{
 while (*T1) UART1_Write(*T1++);
 }

void Init_Timer1(void)
 {
 T1CON=0;




 T1CKPS1_bit=1;
 T1CKPS0_bit=0;
 TMR1H= 0x3C;
 TMR1L= 0xAF;

 Flag_Timer1=0;
 TMR1IP_bit=1;
 PIR1.TMR1IF=0;
 PIE1.TMR1IE=1;
 TMR1ON_bit=1;
}

void Init_ADC()
{
 ADCON0 = 0x00;
 ADCON1 = 0;
 ADCON2 = 0;
 ADCON1.VCFG1=0;
 ADCON1.VCFG0=0;
 ADCON1.PCFG3=1;
 ADCON1.PCFG2=1;
 ADCON1.PCFG1=1;
 ADCON1.PCFG0=0;
 ADCON0.ADON = 1;

 ADCON2.ADFM=1;
 ADCON2.ACQT2=1;
 ADCON2.ACQT1=1;
 ADCON2.ACQT0=1;
 ADCON2.ADCS2=1;
 ADCON2.ADCS1=1;
 ADCON2.ADCS0=1;
}

unsigned int Mesure_ADC( int j)
{
 unsigned int M;


 ADCON0=1 + (j<<2);
 Delay_ms(1);
 ADCON0.GO_DONE = 1;
 _asm NOP;
 while(ADCON0.GO_DONE ==1);
 M = (ADRESH <<8) + ADRESL;
 return M;
}

void Raz_COM()
{
 CptFO=0;CptFE=0;
 for (i=0;i< 80 ;i++) Buffer1[i]=0;
 Flag_Buffer1 = 0;
 Index1=0;
 i1=0;
 c1=0;
 RCIE_bit=1;
}


void UART1_Write_String( char *s)
{
 while (*s)
 {
 UART1_Write(*s++);
 Delay_ms(1);
 }
}

void main()
 {


 OSCTUNE =0;



 OSCCON.SCS1=1;
 OSCCON.SCS0=0;

 OSCCON.IRCF2=1;
 OSCCON.IRCF1=1;
 OSCCON.IRCF0=1;
 Delay_ms(100);


  Drapeaux.Lcd=0; ;

 Init_Hardware();

 Drapeaux.Toggle=0;
 HC06_Enable=0;
#line 797 "C:/_MikroC/_MesProjets_MikroC/_18F2550_BT_HC06/18F2550_Startup_USB_test_BlueTooth_LCD_160124.c"
 Led_Verte=0;
 Secondes=0;
 Led_Rouge=0;

 UART1_Init(9600);
 c1=0;
 UART1_Write( 12 );
 Delay_ms(500);
 CRLF();

 Init_ADC();

 UART1_Write_CText(RS_Str[0]);
 CRLF();
 Delay_ms(500);
 UART1_Write_CText(RS_Str[1]);
 CRLF();

 HC06_Enable=1;
 Delay_ms(100);



 I2C1_Init(100000);
 Delay_ms(100);
 LCD_init_4x20();
 Delay_ms(100);
 Erase_Line(1);
 LCD_Write_CText("18F2550 FOSC 8MHz   ");
 Erase_Line(2);
 LCD_Write_CText(mesg0);
 Delay_ms(1000);
 Erase_Line(3);
 LCD_Write_CText("HC06 BT +UART1 + HID");
 Delay_ms(1000);
 LCD_Msg_Status("Version 23/01/2016   ");
 Delay_ms(1000);




 IPR1.RCIP=1;
 RCON.IPEN = 1;
 PIE1.RCIE = 1;
 INTCON.PEIE = 1;
 INTCON.GIE = 1 ;
 Drapeaux.Toggle=0;

 k=Init_BT_HC06() ;
 LCD_CLS();
 LCD_putcmd( 0x80 ,1); Delay_ms(25);
 if(k>0)
 {
 UART1_Write_CText("\r\n Module BT connect.OK\r\n");
 LCD_putsRom("HC06-2187-J Connect");
 }
 else
 {
 UART1_Write_CText("\r\nPB sur Init Module BT ou Deja connect\r\n");
 LCD_putsRom("PB..connection HC06");
 }

 LCD_putcmd( 0xC0 ,1); Delay_ms(25);
 LCD_putsRom("Init Timer1 1seconde");

 Init_Timer1();
 while (Flag_Timer1==0) ;
 Init_Timer1();

 Raz_COM();
 Nb=0;

 LCD_CLS();
 Erase_Line(1);

 LCD_putsRom("Dialogue BlueTooth  ");








 while(1)
 {
 if (Flag_Buffer1==1)
 {




 LCD_putcmd( 0x80 ,1); Delay_ms(25);
 LCD_putsRom("Reception HC06 BT : ");
 Erase_Line(2);
 strncpy(CRam1,Buffer1,19);
 LCD_puts(CRam1);
 if(strstr(Buffer1,"RED_ON")>0) Led_Rouge=1;
 if(strstr(Buffer1,"RED_OFF")>0) Led_Rouge=0;


 if(strncmp(Buffer1,"GREEN_ON",8)==0) Led_Verte=1;
 if(strncmp(Buffer1,"GREEN_OFF",9)==0) Led_Verte=0;
 if(strstr(Buffer1,"TOGGLE")>0)
 {
 Drapeaux.Toggle=!Drapeaux.Toggle;
 if (Drapeaux.Toggle==1) Erase_Line(4);
 }
 if(strstr(Buffer1,"HELP")>0)
 {
 UART1_Write_CText("Cdes= RED_ON, RED_OFF,GREEN_ON, TOGGLE(ADC mesure),HELP \r\n");
 LCD_CLS();
 LCD_putcmd( 0x80 ,1); Delay_ms(25);

 LCD_putsRom ("Cdes: RED_ON,RED_OFF");
 LCD_putcmd( 0xC0 ,1); Delay_ms(25);
 LCD_putsRom ("GREEN_ON , GREEN_OFF");
 LCD_putcmd( 0x94 ,1); Delay_ms(25);
 LCD_putsRom ("TOGGLE = ADC on/off ");
 LCD_putcmd( 0xD4 ,1); Delay_ms(25);
 LCD_putsRom ("HELP  = this help   ");
 Delay_ms(1000);

 }

 Delay_ms(1500);

 Raz_COM();
 }


 if(Drapeaux.Toggle==1)
 {


 }

 if ((CptFE>10) || (CptFO>10) )
 {
 UART1_Write_CText(RS_Str[2]);
 UART1_Write( 9 );
 WordToStr(CptFE,CRam1);UART1_Write_Text(CRam1);
 WordToStr(CptFO,CRam1);UART1_Write_Text(CRam1);
 CRLF();
 CptFE=0; CptFO=0;
 Raz_COM();
 Delay_ms(500);
 }
 Nb++;
 if ( ( Nb % 10 )==0 )
 {
 if (Drapeaux.Alive==0)
 {
 LCD_Msg_Status(" PB liaison B.T.    ");
 }
 }
 else
 {
 txt=&Texte[0];
 strConstRamCpy(txt,"LR=.;LV=.;TO=.;LI=.;");
 *(txt+3)= ((PORTA & 0x02) >>1) + 48 ;

 *(txt+8)=((PORTB & 0x10) >>4) + 48 ;
#line 963 "C:/_MikroC/_MesProjets_MikroC/_18F2550_BT_HC06/18F2550_Startup_USB_test_BlueTooth_LCD_160124.c"
 *(txt+13)= (Drapeaux.Toggle + 48) ;
 *(txt+18)= (Drapeaux.Alive + 48) ;
 LCD_putcmd( 0x94 ,1); Delay_ms(25);
 LCD_puts(txt);
#line 982 "C:/_MikroC/_MesProjets_MikroC/_18F2550_BT_HC06/18F2550_Startup_USB_test_BlueTooth_LCD_160124.c"
 Ch=0;
 EA0=Mesure_ADC(Ch) ;
 strConstRamCpy(CRam1,"EA0= ");
 k=strlen(CRam1);
 WordToStr(M,CRam1+k);

 k=strlen(CRam1);
 strcat(CRam1+k,";");
 k=strlen(CRam1);
 f1=(float) EA0 * 0.00488;
 strcat(CRam1+k,VirguleToAscii(f1));
 LCD_putcmd( 0xD4 ,1); Delay_ms(25);
 LCD_puts(CRam1); LCD_putch(';');
 k=strlen(txt);
 strcat(txt+k,CRam1);

 UART1_Write_Text(txt);
 UART1_Write('V');
 UART1_Write(';');
 CRLF();
 }


 while (Flag_Timer1==0) ;
 Init_Timer1();
 }
 }
